﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _135656
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            BindingList<Record> data = new BindingList<Record>();
            for (int i = 0; i < 5; i++)
            {
                data.Add(new Record());
            }
            ultraTree1.Override.ShowExpansionIndicator = Infragistics.Win.UltraWinTree.ShowExpansionIndicator.CheckOnDisplay;
            ultraTree1.Dock = DockStyle.Fill;
            ultraTree1.ViewStyle = Infragistics.Win.UltraWinTree.ViewStyle.OutlookExpress;
            ultraTree1.ColumnSetGenerated += ultraTree1_ColumnSetGenerated;
            ultraTree1.ColumnSettings.AutoGenerateColumnSets = true;
            ultraTree1.Appearance.TextTrimming = Infragistics.Win.TextTrimming.None;

            ultraTree1.DataSource = data;
        }

        void ultraTree1_ColumnSetGenerated(object sender, Infragistics.Win.UltraWinTree.ColumnSetGeneratedEventArgs e)
        {
            for (int i = 0; i < e.ColumnSet.Columns.Count; i++)
            {
                Infragistics.Win.UltraWinTree.UltraTreeNodeColumn column = e.ColumnSet.Columns[i];
                string s = column.Key;
                if (column.Key == "RecordType")
                {
                    column.AllowCellEdit = Infragistics.Win.UltraWinTree.AllowCellEdit.Disabled;
                    column.AutoSizeMode = Infragistics.Win.UltraWinTree.ColumnAutoSizeMode.None;
                    column.LayoutInfo.PreferredLabelSize = new System.Drawing.Size(80, 20);
                    column.LayoutInfo.PreferredCellSize = new System.Drawing.Size(80, 20);

                }
                else if (column.Key == "VeryLongString")
                {

                    //pathColumns.Add(column);
                    column.AllowCellEdit = Infragistics.Win.UltraWinTree.AllowCellEdit.Full;
                    column.AutoSizeMode = Infragistics.Win.UltraWinTree.ColumnAutoSizeMode.AllNodesWithDescendants;
                    column.LayoutInfo.AllowLabelSizing = Infragistics.Win.UltraWinTree.LayoutSizing.Horizontal;
                    column.PerformAutoResize();
                }

            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            
            ultraTree1.ColumnSettings.ColumnSets[0].Columns[1].PerformAutoResize(Infragistics.Win.UltraWinTree.ColumnAutoSizeMode.AllNodesWithDescendants);
            ultraTree1.ExpandAll(Infragistics.Win.UltraWinTree.ExpandAllType.OnlyNodesWithChildren);
        }
    }

    public enum RecordTypeEnum { Type1, Type2, Type3 }

    public class Record
    {

        static int Level = 0;
        public RecordTypeEnum RecordType
        {
            get { return RecordTypeEnum.Type1; }

        }

        public String VeryLongString
        {
            get { return @"This is very long text it is so long so it has no sense, but it is good for test purposes and i will use it for this demo "; }
        }
       
        BindingList<Record>  rs;
        public BindingList<Record> Records
        {
            get { return rs;} // tree of child records}
        }

        public Record()
        {
            //RecordType = (_135656.RecordType)(Level % 3);
            rs = new BindingList<Record>();
            if (Level < 20)
            {
                Level++;
                for (int i = 0; i < 2; i++)
                {
                    rs.Add(new Record());
                }
            }
        }

    }

}
